/* mytexture.c	-- Yasuhiro Yamazaki Tue Nov  6 2001
 */
#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "mytexture.h"

#define MYTEXTURE_WIDTH  64
#define MYTEXTURE_HEIGHT 64

GLuint
createMyTexture( void )
{
  int x, y;
  GLuint texture;
  unsigned char data[MYTEXTURE_WIDTH][MYTEXTURE_HEIGHT][3];

  /* ƥޤ */
  glGenTextures( 1, &texture );

  /* ƥꤷޤ */
  glBindTexture( GL_TEXTURE_2D, texture );

  /* ƥΥѥ᡼ꤷޤɬĴ٤Ʋ */
  glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP        );
  glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP        );
  glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST  );
  glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST  );

  /* ƥβǡޤ */
  for( y=0; y<MYTEXTURE_HEIGHT; y++ ){
    for( x=0; x<MYTEXTURE_WIDTH; x++ ){
      data[x][y][0] = (unsigned char) (rand()%256); /* red   */
      data[x][y][1] = (unsigned char) (rand()%256); /* green */
      data[x][y][2] = (unsigned char) (rand()%256); /* blue  */
    }
  }

  /* äǡϤޤ */
  glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, 
		MYTEXTURE_WIDTH, MYTEXTURE_HEIGHT, 0, GL_RGB, 
		GL_UNSIGNED_BYTE, data );

  return texture;
}

void
destroyMyTexture( const GLuint texture )
{
  glDeleteTextures( 1, &texture );
}
