/* pngtexture.c	-- Yasuhiro Yamazaki Tue Nov  6 2001
 */
#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glpng.h>

#include "pngtexture.h"

GLuint
createPngTexture( const char *filename )
{
  pngRawInfo png;
  GLuint texture;

  /* ƥޤ */
  glGenTextures( 1, &texture );

  /* ƥꤷޤ */
  glBindTexture( GL_TEXTURE_2D, texture );

  /* ƥΥѥ᡼ꤷޤɬĴ٤Ʋ */
  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP       );
  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP       );
  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );
  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );

  /* ƥβǡɤߤޤ */
  if( pngLoadRaw( filename, &png ) ){

    /* äǡϤޤ */
    if( !png.Alpha ){
      glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, 
		    png.Width, png.Height, 0, GL_RGB, 
		    GL_UNSIGNED_BYTE, png.Data );
    } else {
      glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, 
		    png.Width, png.Height, 0, GL_RGBA, 
		    GL_UNSIGNED_BYTE, png.Data );
    }
    
    free( png.Data );
    free( png.Palette );
  }
  
  return texture;
}

void
destroyPngTexture( const GLuint texture )
{
  glDeleteTextures( 1, &texture );
}
